# Journal de bord du Mooc / Mooc's logbook

## Module 1

Voir *Notes*.

## Module 2

*2021-02-17*

<!-- :erreurs:, :document_computationnel: -->

### 0. Introduction

Document computationnel, qui permet de présenter à d'autres ses travaux, mais aussi montrer le détail du code et des calculs.

### 1. Document computationnel

- Étude liée aux politiques d'austérité: Erreurs liées à la non-publication des calculs qui ont conduit à la publication.
- Imagerie cérébrale: saumon mort qui présente des signes d'activités cérébrales >> données bruitées, menant à des erreurs d'interprétation. Potentielle remise en cause des résultats publiés ces 15 dernières années (40 000 articles environ), et données pas archivées.
- Fausses structures de protéines >> erreurs de programmation, même si l’acquisition des données était correcte.

Pas un domaine de science est épargné. Problème méthodologique, mais également certainement sociologique. Dans les cas cités, manque de rigueur et de transparence.

*2021-02-18*

### 2. Pourquoi est-ce si difficile?

<!-- :integration_continue:, :git:, :donnees: -->

* Manque d'information:
  - Disponibilité des données
  - Explication des choix
  - D'où, utilisation d'un **cahier de laboratoire**.


* Ordinateur, source d'erreurs:
  - ERP meilleur que tableur pour la compta. Idem pour l'analyse de données.
  - Pile logicielle complexe, notamment avec logiciels propriétaires. Tout reprogrammer nous-même n'est pas non plus une solution. Analyser chaque brique.


* Manque de rigueur et d'organisation.
  - Sauvegarde
  - Mauvaise gestion de versions
  - Revue de code, intégration continue rarement utilisées dans la recherche
  - Dimension culturelle et sociale. La description d'un article ne devrait pas être la norme! Données trop nombreuses pour être décrites de façon exhaustive, idem pour les protocoles. Si personne n'exige les infos à quoi bon s'embêter à les fournir?
    - Cacher des infos peut être suspicieux. Mieux vaut prendre le risque que l'on détecte des erreurs.
    - Qn pourrait en tirer avantage? Oui mais il doit citer notre travail. De plus, les articles les plus cités sont des articles méthodologiques.
    - Possibilité de se faire une carte de visite avec GitHub, en mettant ses travaux à disposition.
    - Données sensibles? Dans ce cas, définir qui peut avoir accès aux infos. Méthodes cryptographiques. >> Informations semi-publiques.


**Outils à éviter**
- Logiciels propriétaires. Aucune garantie sur le long terme.
- Formats binaires non ouverts mènent presque systématiquement à de la perte de données.
- Services d'hébergement propriétaires.
- Tableurs et outils graphiques


**Meilleurs attitude à avoir: transparence.**



### 3. Document computationnel

Permettre la transparence la plus complète possible.

- Acquisition de données: majeure partie du temps derrière un ordinateur.
- Visualisation
- Publication. Attention, l'article est la partie émergée de l'iceberg!

Permettre de refaire le calcul:
- Vérifier
- Corriger
- Réutiliser

Exemples document computationnel: Jupyter notebook, R studio ou Org mode. Principes:
  - Un seul document
  - Session
  - Export

Jupyter: un peu compliqué d'eporter vers un PDF avec un template particulier. Avec Org mode, capacité à écrire directement du LaTeX.


On exporte souvent ensuite vers du PDF ou du HTML. Possibilité de spécifier si ou souhaite cacher certaines sections lors de l'export. Choix de partager le document final, ou bien le doc computationnel lui-même.


### 4. Prise en main de Jupyter

<!-- :jupyter: -->

Réexécuter le kernel afin d'avoir un notebook dans un état cohérent.

Voir `Help > Keybord shortcuts`

`tab`: complétion automatique

`%matplotlib inline` utile?? Autres commandes magiques pour intéragir avec d'autres langages. Ex.: `%load_ext rpy2.python`, puis `%%R`.

`commit & push` pour commiter le doc dans GitHub (uniquement dans le cas du MOOC?)

`Edit > Cell toolbar > Hide code` pour cacher certaines parties.


### 5. Travailler avec d'autres

Produire un document prêt à l'impression demande à avoir un environnement parfaitement configuré.

- Co-auteurs enthousiastes: assurer le service après-vente, pas évident. Différents environnement, prise en main nécessaire... Ceci dit, favorise la reproductibilité.

- Co-auteurs bienveillants: pas de soucis si le document est hébergé sur un cloud. Sinon, les co-auteurs peuvent uniquement éditer l'article avec un éditeur de texte. Le reste est de ma responsabilité.

- Co-auteurs réfractaires:
  - un doc computationnel;
  - et un document plus classiques qui inclut les figures générées par le doc computationnel.

Publier / partager documents:
- Attention à la pérénité! (ex.: Dropbox)
- GitHub ou GitLab: attention, on rend tout l'historique publique! Garder à l'esprit que à terme, les choses seront publiques. Sinon, faire le ménage et archiver l'état courant dans un site compagnon. Ex. archives ouvertes comme HAL. Possibilité de déposer des documents en annexe.


*2021-02-19*


### 6. Analyse comparée des outils

- Cas d'un journal pour la prise de notes avec Org mode. Organisation chronologique, utilisation du mécanisme d'étiquettes pour s'y retrouver. Permet aussi de garder note du code associé si besoin, et de réexécuter à n'importe quel moment. Ensemble hétérogène mais facile à utiliser.

- **Cahier de laboratoire**. Organisation sémantique. Sections avec expériences, analyses... Conventions à expliciter au début du document.

- Article reproductible. Sections :noexport: avec des morceaux de code. Possibilité d'exporter le doc Org mode en Latex, avec un aspect tout à fait normal d'article. Possibilité de modifier facilement une figure en ré-exécutant le code intégré dans le documents. Liens vers le journal correspondant et vers GitHub permettant de revenir aux sources.

Jupyter: lecture directe du ficheir JSOM un peu délicate. A l'inverse, ficheirs Rmd ou Org plus faciles à lire pour un être humain. Rédiger un article de bout en bout avec RStudio ou Org mode de plus en plus souvent faits; possible mais plus compliqué avec Jupyter.
